//go:build example
// +build example

package system

import (
	"code.rocketnine.space/tslocum/gohan"
	"code.rocketnine.space/tslocum/gohan/examples/twinstick/asset"
	"code.rocketnine.space/tslocum/gohan/examples/twinstick/component"
	"github.com/hajimehoshi/ebiten/v2"
)

type DrawBulletsSystem struct {
	Position *component.Position
	Bullet   *component.Bullet

	op *ebiten.DrawImageOptions
}

func NewDrawBulletsSystem() *DrawBulletsSystem {
	return &DrawBulletsSystem{
		op: &ebiten.DrawImageOptions{},
	}
}

func (s *DrawBulletsSystem) Update(_ gohan.Entity) error {
	return gohan.ErrUnregister
}

func (s *DrawBulletsSystem) Draw(_ gohan.Entity, screen *ebiten.Image) error {
	s.op.GeoM.Reset()
	s.op.GeoM.Translate(-16, -16)
	s.op.GeoM.Scale(0.5, 0.5)
	s.op.GeoM.Translate(s.Position.X, s.Position.Y)
	screen.DrawImage(asset.ImgWhiteSquare, s.op)
	return nil
}
